/* @(#)putline.c	13.1.1.1 (ES0-DMD) 06/02/98 18:50:22 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*+++++++++  Remove ESO extensions to FORTRAN 77    ++++++++++++++++++++
.COPYRIGHT   (c) 1988 European Southern Observatory
.LANGUAGE    C
.IDENT       putline.c
.AUTHOR      Preben J. Grosbol [ESO/IPG]
.KEYWORDS    ESO fortran, output line
.ENVIRONMENT UNIX
.COMMENT
.VERSION     1.0   10-Nov-1987: Creation,     PJG
.VERSION     1.1   22-Mar-1988: Correct ENDDO,     PJG
.VERSION     1.2   23-Mar-1988: Redefine 'c' as int,     PJG
.VERSION     1.3   08-Sep-1988: Standard error lists,     PJG
------------------------------------------------------------------------*/
#include   <stdio.h>                        /* standard I/O functions   */
#include   <ctype.h>                        /* character types          */
#include   <f77ext.h>                       /* definition of constants  */
#include   <f77stat.h>                      /* F77 statements           */

extern    int                   bit64;      /* flag for 64bit CPU (=1)  */
extern    int                  x_flag;      /* extension option flag    */
extern    int                  no_lid;      /* no. of line identifiers  */
extern    int                     sno;      /* current no. of labels    */
extern    int                statno[];      /* statement label no.      */
extern    char                 stmt[];      /* present statement        */
extern    char   lbuf[MXLBUF][MXLINE];      /* buffer for input lines   */
extern    LID                   lid[];      /* list of line identifiers */
extern    int                do_level;      /* DO stack pointer         */
extern    int                do_label;      /* DO label                 */

static    int            dostk[MXLDO];      /* DO label stack           */

put_line(ofp,action,stype,labno)            /* correct and output line  */
FILE         *ofp;
int          action;
int          stype;
int          labno;
{
  int          c,n,i,newlab;
  char         *pc,*pnid;
  ID           *pid;

  if (stype == INCLUDE && x_flag & INC_FLAG) return;
  if (stype == IMPLICITNONE && x_flag & IMP_FLAG) return;

  if (x_flag & LN_FLAG)                     /* substitute long names    */
    for (n=0; n<no_lid; n++) {              /* go through all ident.    */
      pid = lid[n].id;
      i = lid[n].size;
      pnid = pid->sname;
      if (i && *pnid) {                     /* modify only long ident.  */
	pc = lid[n].sid;
	while (*pc = *pnid++) { pc++; i--; }
	while (i--) *pc++ = ' ';
      }
    }

  if ((x_flag & DO_FLAG) && action == DO_ACTION) { /* remove DO - ENDDO */
    if (stype == DO) {
      newlab = do_label++;
      dostk[do_level++] = newlab;
      if (MXLDO<do_level) fprintf(stderr,"Error: Stack error in DO-ENDDO");
      statno[sno++] = -newlab;
      if (labno) fprintf(ofp,"%5d DO%5d,",labno,newlab);
	else fprintf(ofp,"      DO%5d,",newlab);
      for (n=0; !lid[n].size && n<no_lid; n++);
      pc = lid[n].sid;
      n = 8;
      while (c = *pc++) {                       /* write out one statement  */
        if (n++<66) putc(c,ofp);
          else { n = 1; fprintf(ofp,"\n     +%c",c); }
      }
      putc('\n',ofp);
    }
    else if (stype == ENDDO) {
      if (do_level<0) fprintf(stderr,"Error: Stack error in DO-ENDDO");
      if (labno) fprintf(ofp,"%5d CONTINUE\n",labno);
      fprintf(ofp,"%5d CONTINUE\n",dostk[--do_level]);
    }
    return;
  }

  if (labno)                                /* write label if any       */
    fprintf(ofp,"%5d ",labno);
   else fprintf(ofp,"      ");


/*  change  INTEGER*8   to   INTEGER  if not 64 bit machine  */
/*  KB  990420  */

if (bit64 == 0)
   {
   if (strncmp(stmt,"INTEGER",7) == 0)
      {
      if ((stmt[7] == '*') && (stmt[8] == '8'))
         {
         stmt[7] = ' ';
         stmt[8] = ' ';
         }
      }
   }


  n = 0; pc = stmt;
  while (c = *pc++) {                       /* write out one statement  */
    if (n++<66) putc(c,ofp);
      else { n = 1; fprintf(ofp,"\n     +%c",c); }
  }
  putc('\n',ofp);

  return;
}
